---
schema_version: "1"
id: 74b48d73653e172ee16c339a74b88fd6226797d6bfd17b68c0ff795ef13b8e22
title: Digital Twin
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/industries-integrations/automotive/references/generated-api-specs/digital-twin.md
canonical_url: https://developer.salesforce.com/docs/industries/automotive/references/digital-twin
source_site: developer.salesforce.com
content_type: documentation
content_hash: c1b899fb67c6718e452c1bb0422ccabdf2c4178d68be22f5bd519fb224d1496a
products:
  - Automotive Cloud Integrations API
  - Industries Integrations
---
Digital Twin

# Digital Twin

Use the Automotive Digital Twin API to get the current vehicle status on demand in Automotive Cloud and perform remote actions on the connected vehicle from Automotive Cloud.

**Version:** 1.0

Protocols: HTTPS.

## Operations

### GET Get vehicle sensor data

`GET /digitalTwin/v1/sensor/{vin}`

Retrieves the sensor values for a vehicle using the vehicle identification number.

#### Parameters

*   `vin` (path, string, required) The unique identifier of the vehicle.  
    Example: `01t1Q000007zUlWQAU`.
*   `attributes` (query, string, required) The attributes of the vehicle for which the sensor data must be fetched.  
    Example: `PERF_ODOMETER,FUEL_LEVEL,RANGE_REMAINING,DOOR_POSITION::ROW_1_RIGHT`.

#### Responses

*   **200**
    
    Media type: `application/json`. Schema: `object`.
    
    _Example_
    
    ```
    "responseData":
      -
        "attributeName": "PERF_ODOMETER"
        "unit": "km"
        "value": "25.0"
        "minValue": ""
        "maxValue": ""
      -
        "attributeName": "FUEL_LEVEL"
        "unit": "ml"
        "value": "80.0"
        "minValue": ""
        "maxValue": ""
      -
        "attributeName": "RANGE_REMAINING"
        "unit": "km"
        "value": "0.0"
        "minValue": ""
        "maxValue": ""
      -
        "attributeName": "DOOR_POS::ROW_1_RIGHT"
        "unit": "NA"
        "value": "0"
        "minValue": ""
        "maxValue": ""
    ```
    
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "400"
    message: Bad request.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **401** Authorization failed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "401"
    message: Unauthorized
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **404** The requested resource was not found.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "404"
    message: Not found.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **405** Method not allowed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "405"
    message: Method not allowed.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **406** Not acceptable.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "406"
    message: Not acceptable.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **415** The media type is not supported.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "415"
    message: Unsupported media type.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "500"
    message: Internal server error.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **501** Not implemented
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "501"
    message: Not implemented.
    isSuccess: false
    correlationId: "1234444"
    ```
    

### GET Get status of a sensor component

`GET /digitalTwin/v1/status/{vin}/telemetry/{component}`

Retrieves the status of a sensor component for a vehicle using the vehicle identification number.

#### Parameters

*   `vin` (path, string, required) The unique identifier of the vehicle.  
    Example: `01t1Q000007zUlWQAU`.
*   `component` (path, string, required) The name of the vehicle component.  
    Example: `DOOR_POSITION`.

#### Responses

*   **200**
    
    Media type: `application/json`. Schema: `object`.
    
    _Example_
    
    ```
    "responseData":
      -
        "attributeName": "DOOR_POSITION::ROW_1_RIGHT"
        "unit": "NA"
        "value": "0"
      -
        "attributeName": "DOOR_POSITION::ROW_2_LEFT"
        "unit": "NA"
        "value": "1"
      -
        "attributeName": "DOOR_POSITION::ROW_1_LEFT"
        "unit": "NA"
        "value": "1"
    ```
    
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "400"
    message: Bad request.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **401** Authorization failed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "401"
    message: Unauthorized
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **404** The requested resource was not found.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "404"
    message: Not found.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **405** Method not allowed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "405"
    message: Method not allowed.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **406** Not acceptable.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "406"
    message: Not acceptable.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **415** The media type is not supported.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "415"
    message: Unsupported media type.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "500"
    message: Internal server error.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **501** Not implemented
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "501"
    message: Not implemented.
    isSuccess: false
    correlationId: "1234444"
    ```
    

### POST Change status of a sensor component

`POST /digitalTwin/v1/command/{vin}`

Changes the status of a vehicle sensor component using the vehicle identification number.

#### Parameters

*   `vin` (path, string, required) The unique identifier of the vehicle.  
    Example: `01t1Q000007zUlWQAU`.

#### Request body

Media type: `application/json`. Schema: `object`.

*   `componentPath` (_string_, required) The path of the component.  
    Example: `vehicle.body.DOOR`.
*   `componentName` (_string_, required) The name of the component.  
    Example: `DOOR_POSITION`.
*   `componentId` (_integer_, required) The unique identifier of the component.  
    Example: `3602`.
*   `uri` (_string_) The location of the resource.  
    Example: `vehicle/body/door`.
*   `payload` (_object_, required) The attributes of the vehicle.

_Example_

```
"componentPath": "vehicle.body.DOOR"
"componentName": "DOOR_POSITION"
"componentId": 3602
"uri": "vehicle/body/door"
"payload":
  "ROW_1_LEFT": "FALSE"
  "ROW_1_RIGHT": "FALSE"
  "ROW_2_LEFT": "TRUE"
  "ROW_2_RIGHT": "FALSE"
  "HOOD": "TRUE"
```

#### Responses

*   **200**
    
    Media type: `application/json`. Schema: `object`.
    
    _Example_
    
    ```
    "responseData":
      "vin": "SIMV1706510440804"
      "trackingId": "679fc1e2-7a70-4cae-ad3c-c582b1dcbacb"
      "details":
        -
          "status": "SUCCESS"
          "statusCode": 103
          "errors": []
    ```
    
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "400"
    message: Bad request.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **401** Authorization failed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "401"
    message: Unauthorized
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **404** The requested resource was not found.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "404"
    message: Not found.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **405** Method not allowed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "405"
    message: Method not allowed.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **406** Not acceptable.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "406"
    message: Not acceptable.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **415** The media type is not supported.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "415"
    message: Unsupported media type.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "500"
    message: Internal server error.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **501** Not implemented
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "501"
    message: Not implemented.
    isSuccess: false
    correlationId: "1234444"
    ```
    

### POST Get the status of the component

`POST /digitalTwin/v1/telemetry/{vin}/status`

#### Parameters

*   `vin` (path, string, required) The unique identifier of the vehicle.  
    Example: `01t1Q000007zUlWQAU`.

#### Request body

Media type: `application/json`. Schema: `array of object`.

Array of `object`.

*   `componentName` (_string_, required)  
    Example: `Vehicle.Cabin.Door.Row1.DriverSide`.
*   `componentPath` (_string_, required)  
    Example: `Vehicle.Cabin.Door.Row1.DriverSide`.
*   `uri` (_string_)  
    Example: `/retrieve/door`.

#### Responses

*   **200**
    
    Media type: `application/json`. Schema: `array of object`.
    
    Array of `object`.
    
    *   `componentName` (_string_, required)  
        Example: `Vehicle.Cabin.Door.Row1.DriverSide`.
    *   `componentPath` (_string_, required)  
        Example: `Vehicle.Cabin.Door.Row1.DriverSide`.
    *   `responseData` (_object_, required)
        *   `isSuccess` (_boolean_, required)  
            Example: `true`.
        *   `code` (_number_) Vendor specific status code  
            Example: `103`.
        *   `statusCode` (_number_, required) HTTP status code  
            Example: `200`.
        *   `message` (_string_)  
            Example: `Telemetry data retrieved successfully`.
        *   `errors` (_array of any_)
            
            _Example_
            
            ```
            []
            ```
            
        *   `data` (_object_, required)
            
            _Example_
            
            ```
            "Vehicle.Cabin.Door.Row1.DriverSide.IsLocked": false
            "Vehicle.Cabin.Door.Row1.DriverSide.Position": 80
            ```
            
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "400"
    message: Bad request.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **401** Authorization failed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "401"
    message: Unauthorized
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **404** The requested resource was not found.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "404"
    message: Not found.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **405** Method not allowed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "405"
    message: Method not allowed.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **406** Not acceptable.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "406"
    message: Not acceptable.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **415** The media type is not supported.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "415"
    message: Unsupported media type.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "500"
    message: Internal server error.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **501** Not implemented
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "501"
    message: Not implemented.
    isSuccess: false
    correlationId: "1234444"
    ```
    

### POST Send remote action

`POST /digitalTwin/v1/telemetry/{vin}/command`

#### Parameters

*   `vin` (path, string, required) The unique identifier of the vehicle.  
    Example: `01t1Q000007zUlWQAU`.

#### Request body

Media type: `application/json`. Schema: `array of object`.

Array of `object`.

*   `componentName` (_string_, required)  
    Example: `Vehicle.Cabin.Door.Row1.DriverSide`.
*   `componentPath` (_string_, required)  
    Example: `Vehicle.Cabin.Door.Row1.DriverSide`.
*   `uri` (_string_)  
    Example: `/submit/door`.
*   `payload` (_object_, required)
    
    _Example_
    
    ```
    "Vehicle.Cabin.Door.Row1.DriverSide.IsLocked": false
    "Vehicle.Cabin.Door.Row1.DriverSide.Position": 80
    ```
    

#### Responses

*   **201**
    
    Media type: `application/json`. Schema: `array of object`.
    
    Array of `object`.
    
    *   `componentName` (_string_, required)  
        Example: `Vehicle.Cabin.Door.Row1.DriverSide`.
    *   `componentPath` (_string_, required)  
        Example: `Vehicle.Cabin.Door.Row1.DriverSide`.
    *   `responseData` (_object_, required)
        *   `isSuccess` (_boolean_, required)  
            Example: `true`.
        *   `code` (_number_) Vendor-specific status code.  
            Example: `103`.
        *   `statusCode` (_number_, required) HTTP status code.  
            Example: `201`.
        *   `message` (_string_)  
            Example: `Telemetry data successfully sent.`.
        *   `errors` (_array of any_)
            
            _Example_
            
            ```
            []
            ```
            
*   **400** There was an issue with your request.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "400"
    message: Bad request.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **401** Authorization failed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "401"
    message: Unauthorized
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **404** The requested resource was not found.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "404"
    message: Not found.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **405** Method not allowed.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "405"
    message: Method not allowed.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **406** Not acceptable.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "406"
    message: Not acceptable.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **415** The media type is not supported.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "415"
    message: Unsupported media type.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **500** Unable to complete the request as the server encountered an error.
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "500"
    message: Internal server error.
    isSuccess: false
    correlationId: "1234444"
    ```
    
*   **501** Not implemented
    
    Media type: `application/json`. Schema: `any`.
    
    Type: `any`.
    
    _Example_
    
    ```
    code: "501"
    message: Not implemented.
    isSuccess: false
    correlationId: "1234444"
    ```